#include <stdio.h>
#include <stdlib.h>
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# ifndef YYLMAX 
# define YYLMAX BUFSIZ
# endif 
#ifndef __cplusplus
# define output(c) (void)putc(c,yyout)
#else
# define lex_output(c) (void)putc(c,yyout)
#endif

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
	int yyback(int *, int);
	int yyinput(void);
	int yylook(void);
	void yyoutput(int);
	int yyracc(int);
	int yyreject(void);
	void yyunput(int);
	int yylex(void);
#ifdef YYLEX_E
	void yywoutput(wchar_t);
	wchar_t yywinput(void);
#endif
#ifndef yyless
	int yyless(int);
#endif
#ifndef yywrap
	int yywrap(void);
#endif
#ifdef LEXDEBUG
	void allprint(char);
	void sprint(char *);
#endif
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#ifdef __cplusplus
extern "C" {
#endif
	void exit(int);
#ifdef __cplusplus
}
#endif

#endif
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
#ifndef __cplusplus
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#else
# define lex_input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#endif
#define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng;
#define YYISARRAY
char yytext[YYLMAX];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;

# line 3 "lex.l"
/*
 * $Header: /Net/aragorn/u3/wkrebs/prg/cvs/queue/lex.c,v 1.1.1.2 1998/08/18 03:43:18 wkrebs Exp $
 * $Log: lex.c,v $
 * Revision 1.1.1.2  1998/08/18 03:43:18  wkrebs
 * * Version 0.22b August, 1998
 *
 *         Upgraded to beta after large numbers of downloads without bug reports
 *         (I know there are bugs left. :-) But, the code is obviously usable. )
 *
 *         Fixed Makefile install bugs :-) Added uninstall option.
 *
 *         Increased SLEEPTIME to 120 to work better on larger clusters.
 *
 *         Added setuid() in queue to correspond to principle of least privilege;
 *         also allows users to send queue signals via KILL instead of just via
 *         the keyboard (I.e., this was a bugfix) :-)
 *
 *         Added Solaris support courtesy of Igor Schein.
 *
 *         Minor changes to documentation.
 *
 *         Announced queue-tips list (write to
 *         queue-tips-request@bioinfo.mbb.yale.edu to join.)
 *
 * Revision 1.1  86/12/31  17:32:46  sahayman
 * Revision 1.2q 98/08/13 wkrebs for queue system
 * 
 */
#include "lex.h"

struct klist {
	char *keyword;
	enum keyword keyvalue;
} klist[] = {
	"exec",		K_EXEC,
	"maxexec",	K_MAXEXEC,
	"vmaxexec",	K_VMAXEXEC,
        "pfactor",      K_PFACTOR,
	"maxqueue",	K_MAXQUEUE,
	"supervisor",	K_SUPERVISOR,
	"mail",		K_MAIL,
        "host",         K_HOST,
	"mailsupervisor", K_MAILSUPERVISOR,
	"console",	K_CONSOLE,
	"nice",		K_NICE,
	"restart",	K_RESTART,
	"timestop",	K_TIMESTOP,
	"timesched",	K_TIMESCHED,
	"day",		K_DAY,
	"off",		K_OFF,
	"drain",	K_DRAIN,
	"on",		K_ON,
	"loadstop",	K_LOADSTOP,
	"loadsched",	K_LOADSCHED,
	"minfree",	K_MINFREE,
	"program",	K_PROGRAM,
	"cpulimit",	K_RLIMITCPU, /* historic synonym for rlimitcpu */
	"rlimitcpu",	K_RLIMITCPU,
	"rlimitfsize",	K_RLIMITFSIZE,
	"rlimitdata",	K_RLIMITDATA,
	"rlimitstack",	K_RLIMITSTACK,
	"rlimitcore",	K_RLIMITCORE,
	"rlimitrss",	K_RLIMITRSS,
	0
};

# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
#ifdef __cplusplus
/* to avoid CC and lint complaining yyfussy not being used ...*/
static int __lex_hack = 0;
if (__lex_hack) goto yyfussy;
#endif
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:

# line 51 "lex.l"
		return (int)K_NUMBER;
break;
case 2:

# line 53 "lex.l"
{
				register struct klist *kp;
				for(kp = klist ; kp->keyword ; kp++)
					if(strcmp(kp->keyword, yytext) == 0)
						return (int)kp->keyvalue;
				return (int)K_VARIABLE;
			}
break;
case 3:

# line 61 "lex.l"
			return (int)K_LINE;
break;
case 4:

# line 63 "lex.l"
			;
break;
case 5:

# line 65 "lex.l"
			;
break;
case 6:

# line 67 "lex.l"
			return (int)K_SYNTAX;
break;
case -1:
break;
default:
(void)fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */

# line 70 "lex.l"

lexfile(f)
FILE *f;
{
	extern struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
	extern int *yyfnd, yyprevious;

	yylineno = 1;
	bzero(yytext, YYLMAX*sizeof yytext[0]);
	bzero(yylstate, sizeof yylstate);
	yylsp = yyolsp = 0;
	bzero(yysbuf, YYLMAX*sizeof yysbuf[0]);
	yysptr = yysbuf;
	yyfnd = 0;
	yyprevious = YYNEWLINE;
	yyleng = 0;
	yymorfg = 0;
	yytchar = 0;
	yyin = f;
	yyestate = 0;
}

yywrap()
{
	return 1;
}
int yyvstop[] = {
0,

6,
0, 

4,
6,
0, 

3,
0, 

2,
6,
0, 

2,
6,
0, 

1,
2,
6,
0, 

6,
-5,
0, 

2,
0, 

1,
2,
0, 

-5,
0, 

5,
0, 
0};
# define YYTYPE unsigned char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,3,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,4,	1,5,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	9,12,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	9,12,	9,13,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	2,9,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	1,6,	1,7,	2,7,	
0,0,	1,8,	6,10,	6,10,	
6,10,	6,10,	6,10,	6,10,	
6,10,	6,10,	6,10,	6,10,	
6,10,	6,10,	6,10,	6,10,	
9,12,	0,0,	0,0,	0,0,	
9,12,	0,0,	0,0,	6,10,	
6,10,	6,10,	6,10,	6,10,	
6,10,	6,10,	6,10,	6,10,	
6,10,	6,10,	6,10,	6,10,	
6,10,	6,10,	6,10,	6,10,	
6,10,	6,10,	6,10,	6,10,	
6,10,	6,10,	6,10,	6,10,	
6,10,	0,0,	0,0,	0,0,	
0,0,	6,10,	0,0,	6,10,	
6,10,	6,10,	6,10,	6,10,	
6,10,	6,10,	6,10,	6,10,	
6,10,	6,10,	6,10,	6,10,	
6,10,	6,10,	6,10,	6,10,	
6,10,	6,10,	6,10,	6,10,	
6,10,	6,10,	6,10,	6,10,	
6,10,	7,11,	7,11,	7,11,	
7,11,	7,11,	7,11,	7,11,	
7,11,	7,11,	7,11,	8,11,	
8,11,	8,11,	8,11,	8,11,	
8,11,	8,11,	8,11,	8,11,	
8,11,	11,11,	11,11,	11,11,	
11,11,	11,11,	11,11,	11,11,	
11,11,	11,11,	11,11,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-2,	yysvec+1,	0,	
yycrank+0,	0,		yyvstop+1,
yycrank+0,	0,		yyvstop+3,
yycrank+0,	0,		yyvstop+6,
yycrank+6,	0,		yyvstop+8,
yycrank+81,	yysvec+6,	yyvstop+11,
yycrank+91,	yysvec+6,	yyvstop+14,
yycrank+-20,	0,		yyvstop+18,
yycrank+0,	yysvec+6,	yyvstop+21,
yycrank+101,	yysvec+6,	yyvstop+23,
yycrank+0,	yysvec+9,	yyvstop+26,
yycrank+0,	0,		yyvstop+28,
0,	0,	0};
struct yywork *yytop = yycrank+158;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
  0,   1,   1,   1,   1,   1,   1,   1, 
  1,   9,  10,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  9,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,  44,  44,  44,  44, 
 48,  48,  48,  48,  48,  48,  48,  48, 
 48,  48,   1,   1,   1,   1,   1,   1, 
  1,  44,  44,  44,  44,  44,  44,  44, 
 44,  44,  44,  44,  44,  44,  44,  44, 
 44,  44,  44,  44,  44,  44,  44,  44, 
 44,  44,  44,   1,   1,   1,   1,  44, 
  1,  44,  44,  44,  44,  44,  44,  44, 
 44,  44,  44,  44,  44,  44,  44,  44, 
 44,  44,  44,  44,  44,  44,  44,  44, 
 44,  44,  44,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
  1,   1,   1,   1,   1,   1,   1,   1, 
0};
char yyextra[] = {
0,0,0,0,0,1,0,0,
0};
/*	Copyright (c) 1989 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#pragma ident	"@(#)ncform	6.11	97/01/06 SMI"

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;
#if defined(__cplusplus) || defined(__STDC__)
int yylook(void)
#else
yylook()
#endif
{
	register struct yysvf *yystate, **lsp;
	register struct yywork *yyt;
	struct yysvf *yyz;
	int yych, yyfirst;
	struct yywork *yyr;
# ifdef LEXDEBUG
	int debug;
# endif
	char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
#ifndef __cplusplus
			*yylastch++ = yych = input();
#else
			*yylastch++ = yych = lex_input();
#endif
#ifdef YYISARRAY
			if(yylastch > &yytext[YYLMAX]) {
				fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
				exit(1);
			}
#else
			if (yylastch >= &yytext[ yytextsz ]) {
				int	x = yylastch - yytext;

				yytextsz += YYTEXTSZINC;
				if (yytext == yy_tbuf) {
				    yytext = (char *) malloc(yytextsz);
				    memcpy(yytext, yy_tbuf, sizeof (yy_tbuf));
				}
				else
				    yytext = (char *) realloc(yytext, yytextsz);
				if (!yytext) {
				    fprintf(yyout,
					"Cannot realloc yytext\n");
				    exit(1);
				}
				yylastch = yytext + x;
			}
#endif
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					if(lsp > &yylstate[YYLMAX]) {
						fprintf(yyout,"Input string too long, limit %d\n",YYLMAX);
						exit(1);
					}
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
#ifndef __cplusplus
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
#else
		yyprevious = yytext[0] = lex_input();
		if (yyprevious>0)
			lex_output(yyprevious);
#endif
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
#if defined(__cplusplus) || defined(__STDC__)
int yyback(int *p, int m)
#else
yyback(p, m)
	int *p;
#endif
{
	if (p==0) return(0);
	while (*p) {
		if (*p++ == m)
			return(1);
	}
	return(0);
}
	/* the following are only used in the lex library */
#if defined(__cplusplus) || defined(__STDC__)
int yyinput(void)
#else
yyinput()
#endif
{
#ifndef __cplusplus
	return(input());
#else
	return(lex_input());
#endif
	}
#if defined(__cplusplus) || defined(__STDC__)
void yyoutput(int c)
#else
yyoutput(c)
  int c; 
#endif
{
#ifndef __cplusplus
	output(c);
#else
	lex_output(c);
#endif
	}
#if defined(__cplusplus) || defined(__STDC__)
void yyunput(int c)
#else
yyunput(c)
   int c; 
#endif
{
	unput(c);
	}
